<!-- 编辑弹窗 -->
<template>
  <ele-modal
    width="70%"
    :visible="visible"
    :maskClosable="false"
    :maxable="maxable"
    :title="isUpdate ? '行政许可详情' : '添加行政许可'"
    :body-style="{ paddingBottom: '28px' }"
    @update:visible="updateVisible"
    :footer="null"
    @ok="save"
  >
    <a-form
      ref="formRef"
      :model="form"
      :rules="rules"
      :label-col="styleResponsive ? { md: 4, sm: 5, xs: 24 } : { flex: '90px' }"
      :wrapper-col="
        styleResponsive ? { md: 19, sm: 19, xs: 24 } : { flex: '1' }
      "
    >
      <a-form-item label="决定文书/许可编号" name="code">
        <a-input
          allow-clear
          placeholder="请输入决定文书/许可编号"
          v-model:value="form.code"
        />
      </a-form-item>
      <a-form-item label="决定文书/许可证名称" name="name">
        <a-input
          allow-clear
          placeholder="请输入决定文书/许可证名称"
          v-model:value="form.name"
        />
      </a-form-item>
      <a-form-item label="许可状态" name="statusText">
        <a-input
          allow-clear
          placeholder="请输入许可状态"
          v-model:value="form.statusText"
        />
      </a-form-item>
      <a-form-item label="许可类型" name="type">
        <a-input
          allow-clear
          placeholder="请输入许可类型"
          v-model:value="form.type"
        />
      </a-form-item>
      <a-form-item label="有效期自" name="validityStart">
        <a-input
          allow-clear
          placeholder="请输入有效期自"
          v-model:value="form.validityStart"
        />
      </a-form-item>
      <a-form-item label="有效期至" name="validityEnd">
        <a-input
          allow-clear
          placeholder="请输入有效期至"
          v-model:value="form.validityEnd"
        />
      </a-form-item>
      <a-form-item label="许可机关" name="licensingAuthority">
        <a-input
          allow-clear
          placeholder="请输入许可机关"
          v-model:value="form.licensingAuthority"
        />
      </a-form-item>
      <a-form-item label="许可内容" name="licenseContent">
        <a-input
          allow-clear
          placeholder="请输入许可内容"
          v-model:value="form.licenseContent"
        />
      </a-form-item>
      <a-form-item label="数据来源单位" name="dataSourceUnit">
        <a-input
          allow-clear
          placeholder="请输入数据来源单位"
          v-model:value="form.dataSourceUnit"
        />
      </a-form-item>
    </a-form>
  </ele-modal>
</template>

<script lang="ts" setup>
  import { ref, reactive, watch } from 'vue';
  import { Form, message } from 'ant-design-vue';
  import { assignObject, uuid } from 'ele-admin-pro';
  import {
    addCreditAdministrativeLicense,
    updateCreditAdministrativeLicense
  } from '@/api/credit/creditAdministrativeLicense';
  import { CreditAdministrativeLicense } from '@/api/credit/creditAdministrativeLicense/model';
  import { useThemeStore } from '@/store/modules/theme';
  import { storeToRefs } from 'pinia';
  import { ItemType } from 'ele-admin-pro/es/ele-image-upload/types';
  import { FormInstance } from 'ant-design-vue/es/form';
  import { FileRecord } from '@/api/system/file/model';

  // 是否是修改
  const isUpdate = ref(false);
  const useForm = Form.useForm;
  // 是否开启响应式布局
  const themeStore = useThemeStore();
  const { styleResponsive } = storeToRefs(themeStore);

  const props = defineProps<{
    // 弹窗是否打开
    visible: boolean;
    // 修改回显的数据
    data?: CreditAdministrativeLicense | null;
  }>();

  const emit = defineEmits<{
    (e: 'done'): void;
    (e: 'update:visible', visible: boolean): void;
  }>();

  // 提交状态
  const loading = ref(false);
  // 是否显示最大化切换按钮
  const maxable = ref(true);
  // 表格选中数据
  const formRef = ref<FormInstance | null>(null);
  const images = ref<ItemType[]>([]);

  // 用户信息
  const form = reactive<CreditAdministrativeLicense>({
    id: undefined,
    code: undefined,
    name: undefined,
    statusText: undefined,
    type: undefined,
    url: undefined,
    validityStart: undefined,
    validityEnd: undefined,
    licensingAuthority: undefined,
    licenseContent: undefined,
    dataSourceUnit: undefined,
    comments: undefined,
    companyId: undefined,
    recommend: undefined,
    sortNumber: undefined,
    status: undefined,
    deleted: undefined,
    userId: undefined,
    tenantId: undefined,
    createTime: undefined,
    updateTime: undefined,
    creditAdministrativeLicenseId: undefined,
    creditAdministrativeLicenseName: '',
    status: 0,
    comments: '',
    sortNumber: 100
  });

  /* 更新visible */
  const updateVisible = (value: boolean) => {
    emit('update:visible', value);
  };

  // 表单验证规则
  const rules = reactive({
    creditAdministrativeLicenseName: [
      {
        required: true,
        type: 'string',
        message: '请填写行政许可名称',
        trigger: 'blur'
      }
    ]
  });

  const chooseImage = (data: FileRecord) => {
    images.value.push({
      uid: data.id,
      url: data.path,
      status: 'done'
    });
    form.image = data.path;
  };

  const onDeleteItem = (index: number) => {
    images.value.splice(index, 1);
    form.image = '';
  };

  const { resetFields } = useForm(form, rules);

  /* 保存编辑 */
  const save = () => {
    if (!formRef.value) {
      return;
    }
    formRef.value
      .validate()
      .then(() => {
        loading.value = true;
        const formData = {
          ...form
        };
        const saveOrUpdate = isUpdate.value
          ? updateCreditAdministrativeLicense
          : addCreditAdministrativeLicense;
        saveOrUpdate(formData)
          .then((msg) => {
            loading.value = false;
            message.success(msg);
            updateVisible(false);
            emit('done');
          })
          .catch((e) => {
            loading.value = false;
            message.error(e.message);
          });
      })
      .catch(() => {});
  };

  watch(
    () => props.visible,
    (visible) => {
      if (visible) {
        images.value = [];
        if (props.data) {
          assignObject(form, props.data);
          if (props.data.image) {
            images.value.push({
              uid: uuid(),
              url: props.data.image,
              status: 'done'
            });
          }
          isUpdate.value = true;
        } else {
          isUpdate.value = false;
        }
      } else {
        resetFields();
      }
    },
    { immediate: true }
  );
</script>
